//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "BCB5068.h"
#include "..\..\..\include\BlockIOAPI.h"
#include "..\..\..\include\BlockIO5068.h"

#pragma link "..\\..\\..\\library\\bcbBlockIOAPIr.lib"
#pragma link "..\\..\\..\\library\\bcbBlockIO5068r.lib"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TBCB5068Main *BCB5068Main;
//---------------------------------------------------------------------------
__fastcall TBCB5068Main::~TBCB5068Main(void)
{
        Timer1->Enabled = FALSE;
        if(mHandle) SYS_Release(mHandle);
}
//---------------------------------------------------------------------------
__fastcall TBCB5068Main::TBCB5068Main(TComponent* Owner)
        : TForm(Owner)
{
        mHandle = 0;
}
//---------------------------------------------------------------------------
void __fastcall TBCB5068Main::OpenClick(TObject *Sender)
{
        if(IA->Text.IsEmpty())
        {
                Application->MessageBox("Please input IP address!",
                 "System Message", MB_APPLMODAL|MB_OK|MB_ICONSTOP);
                return;
        }
        Open->Enabled = FALSE;
        DWORD dwRet = SYS_Install(&mHandle, IA->Text.c_str());
        if(!ERR_OK(dwRet))
        {
                dwRet = dwRet & 0x00FF;
                Application->MessageBox(Format("Function SYS_Install returns error code: %d!", ARRAYOFCONST(((int)dwRet))).c_str(),
                 "System Message", MB_APPLMODAL|MB_OK|MB_ICONSTOP);
                Open->Enabled = TRUE;
                return;
        }

        char szBuf[20] = "";
        SYS_GetModuleName(mHandle, szBuf, 20);
        MN->Text = szBuf;

        memset(szBuf, 0, sizeof(szBuf));
        SYS_GetModuleFirmware(mHandle, szBuf, 20);
        FV->Text = szBuf;

        BOOL bEnabled;
        double dblWDTimer;
        SYS_GetWatchDogConfig(mHandle, &bEnabled, &dblWDTimer);
        WD->Checked = bEnabled;
        WDT->Text = Format("%f", ARRAYOFCONST((dblWDTimer)));
        WD->Enabled = TRUE;
        WDT->Enabled = TRUE;
        Update->Enabled = TRUE;

        BYTE dwDI[2], dwDO;
        DIO_GetDIO(mHandle, dwDI, &dwDO);

        DI0->Checked = dwDI[0] & (1 << 0);
        DI1->Checked = dwDI[0] & (1 << 1);
        DI2->Checked = dwDI[0] & (1 << 2);
        DI3->Checked = dwDI[0] & (1 << 3);
        DI4->Checked = dwDI[0] & (1 << 4);
        DI5->Checked = dwDI[0] & (1 << 5);
        DI6->Checked = dwDI[0] & (1 << 6);
        DI7->Checked = dwDI[0] & (1 << 7);
        DI8->Checked = dwDI[1] & (1 << 0);
        DI9->Checked = dwDI[1] & (1 << 1);
        DI10->Checked = dwDI[1] & (1 << 2);
        DI11->Checked = dwDI[1] & (1 << 3);
        DI12->Checked = dwDI[1] & (1 << 4);
        DI13->Checked = dwDI[1] & (1 << 5);

        DO0->Checked = dwDO & (1 << 0);
        DO1->Checked = dwDO & (1 << 1);
        DO2->Checked = dwDO & (1 << 2);
        DO3->Checked = dwDO & (1 << 3);
        DO4->Checked = dwDO & (1 << 4);
        DO5->Checked = dwDO & (1 << 5);
        DO6->Checked = dwDO & (1 << 6);
        DO7->Checked = dwDO & (1 << 7);

        DO0->Enabled = TRUE;
        DO1->Enabled = TRUE;
        DO2->Enabled = TRUE;
        DO3->Enabled = TRUE;
        DO4->Enabled = TRUE;
        DO5->Enabled = TRUE;
        DO6->Enabled = TRUE;
        DO7->Enabled = TRUE;

        SetS->Enabled = TRUE;
        SetP->Enabled = TRUE;

        Timer1->Enabled = TRUE;

        Close->Enabled = TRUE;        
}
//---------------------------------------------------------------------------
void __fastcall TBCB5068Main::CloseClick(TObject *Sender)
{
        Timer1->Enabled = FALSE;

        Close->Enabled = FALSE;

        SYS_Release(mHandle);
        mHandle = NULL;

        WD->Enabled = FALSE;
        WD->Checked = FALSE;
        WDT->Enabled = FALSE;
        Update->Enabled = FALSE;
        Open->Enabled = TRUE;

        WDT->Text = "";
        MN->Text = "";
        FV->Text = "";

        DI0->Checked = FALSE;
        DI1->Checked = FALSE;
        DI2->Checked = FALSE;
        DI3->Checked = FALSE;
        DI4->Checked = FALSE;
        DI5->Checked = FALSE;
        DI6->Checked = FALSE;
        DI7->Checked = FALSE;
        DI8->Checked = FALSE;
        DI9->Checked = FALSE;
        DI10->Checked = FALSE;
        DI11->Checked = FALSE;
        DI12->Checked = FALSE;
        DI13->Checked = FALSE;

        DO0->Enabled = FALSE;
        DO1->Enabled = FALSE;
        DO2->Enabled = FALSE;
        DO3->Enabled = FALSE;
        DO4->Enabled = FALSE;
        DO5->Enabled = FALSE;
        DO6->Enabled = FALSE;
        DO7->Enabled = FALSE;        
}
//---------------------------------------------------------------------------
void __fastcall TBCB5068Main::Timer1Timer(TObject *Sender)
{
        BYTE dwDI[2], dwDO;
        DIO_GetDIO(mHandle, dwDI, &dwDO);

        DI0->Checked = dwDI[0] & (1 << 0);
        DI1->Checked = dwDI[0] & (1 << 1);
        DI2->Checked = dwDI[0] & (1 << 2);
        DI3->Checked = dwDI[0] & (1 << 3);
        DI4->Checked = dwDI[0] & (1 << 4);
        DI5->Checked = dwDI[0] & (1 << 5);
        DI6->Checked = dwDI[0] & (1 << 6);
        DI7->Checked = dwDI[0] & (1 << 7);
        DI8->Checked = dwDI[0] & (1 << 0);
        DI9->Checked = dwDI[1] & (1 << 1);
        DI10->Checked = dwDI[1] & (1 << 2);
        DI11->Checked = dwDI[1] & (1 << 3);
        DI12->Checked = dwDI[1] & (1 << 4);
        DI13->Checked = dwDI[1] & (1 << 5);

        DO0->Checked = dwDO & (1 << 0);
        DO1->Checked = dwDO & (1 << 1);
        DO2->Checked = dwDO & (1 << 2);
        DO3->Checked = dwDO & (1 << 3);
        DO4->Checked = dwDO & (1 << 4);
        DO5->Checked = dwDO & (1 << 5);
        DO6->Checked = dwDO & (1 << 6);
        DO7->Checked = dwDO & (1 << 7);        
}
//---------------------------------------------------------------------------
void __fastcall TBCB5068Main::WDClick(TObject *Sender)
{
        if (WD->Checked==TRUE)
                SYS_EnableWatchDog(mHandle);
        else
                SYS_DisableWatchDog(mHandle);            
}
//---------------------------------------------------------------------------
void __fastcall TBCB5068Main::UpdateClick(TObject *Sender)
{
        double dblWDTimer = atof(WDT->Text.c_str());
        SYS_SetWatchDogConfig(mHandle, WD->Checked, dblWDTimer);        
}
//---------------------------------------------------------------------------
void __fastcall TBCB5068Main::SetSClick(TObject *Sender)
{
        DIO_SetSafetyDO(mHandle);        
}
//---------------------------------------------------------------------------
void __fastcall TBCB5068Main::SetPClick(TObject *Sender)
{
        DIO_SetPowerOnDO(mHandle);        
}
//---------------------------------------------------------------------------
void __fastcall TBCB5068Main::OKClick(TObject *Sender)
{
        Timer1->Enabled = FALSE;
        if(mHandle) SYS_Release(mHandle);
        Application->Terminate();        
}
//---------------------------------------------------------------------------
void __fastcall TBCB5068Main::DO0Click(TObject *Sender)
{
        DIO_SetDO(mHandle, 0, DO0->Checked);        
}
//---------------------------------------------------------------------------
void __fastcall TBCB5068Main::DO1Click(TObject *Sender)
{
        DIO_SetDO(mHandle, 1, DO1->Checked);        
}
//---------------------------------------------------------------------------
void __fastcall TBCB5068Main::DO2Click(TObject *Sender)
{
        DIO_SetDO(mHandle, 2, DO2->Checked);        
}
//---------------------------------------------------------------------------
void __fastcall TBCB5068Main::DO3Click(TObject *Sender)
{
        DIO_SetDO(mHandle, 3, DO3->Checked);        
}
//---------------------------------------------------------------------------
void __fastcall TBCB5068Main::DO4Click(TObject *Sender)
{
        DIO_SetDO(mHandle, 4, DO4->Checked);        
}
//---------------------------------------------------------------------------
void __fastcall TBCB5068Main::DO5Click(TObject *Sender)
{
        DIO_SetDO(mHandle, 5, DO5->Checked);        
}
//---------------------------------------------------------------------------
void __fastcall TBCB5068Main::DO6Click(TObject *Sender)
{
        DIO_SetDO(mHandle, 6, DO6->Checked);        
}
//---------------------------------------------------------------------------
void __fastcall TBCB5068Main::DO7Click(TObject *Sender)
{
        DIO_SetDO(mHandle, 7, DO7->Checked);        
}
//---------------------------------------------------------------------------
void __fastcall TBCB5068Main::FormClose(TObject *Sender,
      TCloseAction &Action)
{
        if(mHandle) SYS_Release(mHandle);        
}
//---------------------------------------------------------------------------

