//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "BCB5024.h"
#include "..\..\..\include\BlockIOAPI.h"
#include "..\..\..\include\BlockIO5024.h"

#pragma link "..\\..\\..\\library\\bcbBlockIOAPIr.lib"
#pragma link "..\\..\\..\\library\\bcbBlockIO5024r.lib"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TBCB5024Main *BCB5024Main;
//---------------------------------------------------------------------------
__fastcall TBCB5024Main::~TBCB5024Main(void)
{
        Timer1->Enabled = FALSE;
        if(mHandle) SYS_Release(mHandle);
}
//---------------------------------------------------------------------------
__fastcall TBCB5024Main::TBCB5024Main(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TBCB5024Main::OpenClick(TObject *Sender)
{
        if(IA->Text.IsEmpty())
        {
                Application->MessageBox("Please input IP address!",
                 "System Message", MB_APPLMODAL|MB_OK|MB_ICONSTOP);
                return;
        }
        Open->Enabled = FALSE;
        DWORD dwRet = SYS_Install(&mHandle, IA->Text.c_str());
        if(!ERR_OK(dwRet))
        {
                dwRet = dwRet & 0x00FF;
                Application->MessageBox(Format("Function SYS_Install returns error code: %d!", ARRAYOFCONST(((int)dwRet))).c_str(),
                 "System Message", MB_APPLMODAL|MB_OK|MB_ICONSTOP);
                Open->Enabled = TRUE;
                return;
        }

        UpdateIR->Enabled;
        cmoSlewRate->Enabled = TRUE;
        cmbOutputRange0->Enabled = True;
        UpdateIR->Enabled = TRUE;
        Close->Enabled = TRUE;

        char szBuf[20] = "";
        SYS_GetModuleName(mHandle, szBuf, 20);
        MN->Text = szBuf;

        memset(szBuf, 0, sizeof(szBuf));
        SYS_GetModuleFirmware(mHandle, szBuf, 20);
        FV->Text = szBuf;

        BOOL bEnabled;
        double dblWDTimer;
        SYS_GetWatchDogConfig(mHandle, &bEnabled, &dblWDTimer);
        WD->Checked = bEnabled;
        WDT->Text = Format("%f", ARRAYOFCONST((dblWDTimer)));
        WD->Enabled = TRUE;
        WDT->Enabled = TRUE;
        Update->Enabled = TRUE;

        //JetIO5024 AO & Config
        double dbValue[I5024_CH_NUM];
        DWORD ret = AO_GetAO(mHandle, 255, &dbValue[0]);
        txtAO0->Text = dbValue[0];
        txtAO1->Text = dbValue[1];
        txtAO2->Text = dbValue[2];
        txtAO3->Text = dbValue[3];
        Timer1->Enabled = TRUE;

        //Output & Slew Range
        cmbOutputRange0->Enabled = TRUE;
        cmoSlewRate->Enabled = TRUE;
        I5024_PARAM byRange;
        ret = AO_GetConfig(mHandle, &byRange);
        cmbOutputRange0->ItemIndex = byRange.byOutputRanges[0];
        if (cmbOutputRange0->ItemIndex == 0)
        {
            cmoSlewRate->Clear();
            cmoSlewRate->AddItem("immediate change",NULL);
            cmoSlewRate->AddItem("0.0625",NULL);
            cmoSlewRate->AddItem("0.125",NULL);
            cmoSlewRate->AddItem("0.25",NULL);
            cmoSlewRate->AddItem("0.5",NULL);
            cmoSlewRate->AddItem("1.0",NULL);
            cmoSlewRate->AddItem("2.0",NULL);
            cmoSlewRate->AddItem("4.0",NULL);
            cmoSlewRate->AddItem("8.0",NULL);
            cmoSlewRate->AddItem("16.0",NULL);
            cmoSlewRate->AddItem("32.0",NULL);
            cmoSlewRate->AddItem ("64.0",NULL);
        }

        if(cmbOutputRange0->ItemIndex== 1)
        {
                cmoSlewRate->Clear();
                cmoSlewRate->AddItem("immediate change",NULL);
                cmoSlewRate->AddItem("0.125",NULL);
                cmoSlewRate->AddItem("0.25",NULL);
                cmoSlewRate->AddItem("0.5",NULL);
                cmoSlewRate->AddItem("1.0",NULL);
                cmoSlewRate->AddItem("2.0",NULL);
                cmoSlewRate->AddItem("4.0",NULL);
                cmoSlewRate->AddItem("8.0",NULL);
                cmoSlewRate->AddItem("16.0",NULL);
                cmoSlewRate->AddItem("32.0",NULL);
                cmoSlewRate->AddItem("64.0",NULL);
                cmoSlewRate->AddItem("128.0",NULL);
        }
        cmoSlewRate->ItemIndex = byRange.bySlewRates[0];

        Timer1->Enabled = TRUE;
        cmdSetAO0->Enabled = TRUE;
        cmdSetPower0->Enabled = TRUE;
        cmdSetAO1->Enabled = TRUE;
        cmdSetPower1->Enabled = TRUE;
        cmdSetAO2->Enabled = TRUE;
        cmdSetPower2->Enabled = TRUE;
        cmdSetAO3->Enabled = TRUE;
        cmdSetPower3->Enabled = TRUE;

        txtSetAO0->Enabled = TRUE;
        txtSetAO1->Enabled = TRUE;
        txtSetAO2->Enabled = TRUE;
        txtSetAO3->Enabled = TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TBCB5024Main::CloseClick(TObject *Sender)
{
        Timer1->Enabled = FALSE;

        Close->Enabled = FALSE;

        SYS_Release(mHandle);
        mHandle = NULL;

        WD->Enabled = FALSE;
        //WD->Checked = FALSE;
        WDT->Enabled = FALSE;
        Update->Enabled = FALSE;
        Open->Enabled = TRUE;
        Close->Enabled = FALSE;
        UpdateIR->Enabled = FALSE;

        WDT->Text = "";
        MN->Text = "";
        FV->Text = "";

        cmoSlewRate->ItemIndex = 0;
        cmoSlewRate->Enabled = FALSE;
        cmbOutputRange0->Enabled = FALSE;
//JetIO5024
        cmdSetAO0->Enabled = FALSE;
        cmdSetPower0->Enabled = FALSE;
        cmdSetAO1->Enabled = FALSE;
        cmdSetPower1->Enabled = FALSE;
        cmdSetAO2->Enabled = FALSE;
        cmdSetPower2->Enabled = FALSE;
        cmdSetAO3->Enabled = FALSE;
        cmdSetPower3->Enabled = FALSE;

        txtSetAO0->Enabled = FALSE;
        txtSetAO1->Enabled = FALSE;
        txtSetAO2->Enabled = FALSE;
        txtSetAO3->Enabled = FALSE;

}
//---------------------------------------------------------------------------
void __fastcall TBCB5024Main::WDClick(TObject *Sender)
{
        if (WD->Checked==TRUE)
                SYS_EnableWatchDog(mHandle);
        else
                SYS_DisableWatchDog(mHandle);        
}
//---------------------------------------------------------------------------
void __fastcall TBCB5024Main::UpdateClick(TObject *Sender)
{
        double dblWDTimer = atof(WDT->Text.c_str());
        SYS_SetWatchDogConfig(mHandle, WD->Checked, dblWDTimer);             
}
//---------------------------------------------------------------------------
void __fastcall TBCB5024Main::cmbOutputRange0Change(TObject *Sender)
{
        if (cmbOutputRange0->ItemIndex == 0)
        {
            cmoSlewRate->Clear();
            cmoSlewRate->AddItem("immediate change",NULL);
            cmoSlewRate->AddItem("0.0625",NULL);
            cmoSlewRate->AddItem("0.125",NULL);
            cmoSlewRate->AddItem("0.25",NULL);
            cmoSlewRate->AddItem("0.5",NULL);
            cmoSlewRate->AddItem("1.0",NULL);
            cmoSlewRate->AddItem("2.0",NULL);
            cmoSlewRate->AddItem("4.0",NULL);
            cmoSlewRate->AddItem("8.0",NULL);
            cmoSlewRate->AddItem("16.0",NULL);
            cmoSlewRate->AddItem("32.0",NULL);
            cmoSlewRate->AddItem ("64.0",NULL);
        }

        if(cmbOutputRange0->ItemIndex== 1)
        {
                cmoSlewRate->Clear();
                cmoSlewRate->AddItem("immediate change",NULL);
                cmoSlewRate->AddItem("0.125",NULL);
                cmoSlewRate->AddItem("0.25",NULL);
                cmoSlewRate->AddItem("0.5",NULL);
                cmoSlewRate->AddItem("1.0",NULL);
                cmoSlewRate->AddItem("2.0",NULL);
                cmoSlewRate->AddItem("4.0",NULL);
                cmoSlewRate->AddItem("8.0",NULL);
                cmoSlewRate->AddItem("16.0",NULL);
                cmoSlewRate->AddItem("32.0",NULL);
                cmoSlewRate->AddItem("64.0",NULL);
                cmoSlewRate->AddItem("128.0",NULL);
        }
        cmoSlewRate->ItemIndex = 0;
}
//---------------------------------------------------------------------------
void __fastcall TBCB5024Main::Timer1Timer(TObject *Sender)
{
        double dbValue[I5024_CH_NUM];
        DWORD ret = AO_GetAO(mHandle, 255, &dbValue[0]);
        txtAO0->Text = dbValue[0];
        txtAO1->Text = dbValue[1];
        txtAO2->Text = dbValue[2];
        txtAO3->Text = dbValue[3];
}
//---------------------------------------------------------------------------
void __fastcall TBCB5024Main::UpdateIRClick(TObject *Sender)
{

        int bySlewRate = cmoSlewRate->ItemIndex;

        I5024_PARAM byRange;
        byRange.bySlewRates[0] = cmoSlewRate->ItemIndex;
        byRange.bySlewRates[1] = cmoSlewRate->ItemIndex;
        byRange.bySlewRates[2] = cmoSlewRate->ItemIndex;
        byRange.bySlewRates[3] = cmoSlewRate->ItemIndex;
        byRange.byOutputRanges[0] = cmbOutputRange0->ItemIndex;
        byRange.byOutputRanges[1] = cmbOutputRange0->ItemIndex;
        byRange.byOutputRanges[2] = cmbOutputRange0->ItemIndex;
        byRange.byOutputRanges[3] = cmbOutputRange0->ItemIndex;
        byRange.byMask = 3;
        DWORD ret = AO_SetConfig(mHandle, &byRange);
}
//---------------------------------------------------------------------------
void __fastcall TBCB5024Main::cmdSetAO0Click(TObject *Sender)
{
        double dbAO;
        if (txtSetAO0->Text == " ")
                dbAO = 0;
        else
                dbAO = atof(txtSetAO0->Text.c_str());

        DWORD ret = AO_SetAO(mHandle, 0, dbAO);
}
//---------------------------------------------------------------------------
void __fastcall TBCB5024Main::cmdSetPower0Click(TObject *Sender)
{
        DWORD ret = AO_SetPowerOnValue(mHandle, 0);
}
//---------------------------------------------------------------------------
void __fastcall TBCB5024Main::cmdSetAO2Click(TObject *Sender)
{
        double dbAO;
        if (txtSetAO2->Text== " ")
                dbAO = 0;
        else
                dbAO = atof(txtSetAO2->Text.c_str());

        DWORD ret = AO_SetAO(mHandle, 2, dbAO);
}
//---------------------------------------------------------------------------
void __fastcall TBCB5024Main::cmdSetPower2Click(TObject *Sender)
{
        DWORD ret = AO_SetPowerOnValue(mHandle, 2);
}
//---------------------------------------------------------------------------
void __fastcall TBCB5024Main::cmdSetAO1Click(TObject *Sender)
{
        double dbAO;
        if (txtSetAO1->Text == " ")
                dbAO = 0;
        else
                dbAO = atof(txtSetAO1->Text.c_str());
        DWORD ret = AO_SetAO(mHandle, 1, dbAO);
}
//---------------------------------------------------------------------------
void __fastcall TBCB5024Main::cmdSetPower1Click(TObject *Sender)
{
        DWORD ret = AO_SetPowerOnValue(mHandle, 1);
}
//---------------------------------------------------------------------------
void __fastcall TBCB5024Main::cmdSetAO3Click(TObject *Sender)
{
        double dbAO;
        if (txtSetAO3->Text == " ")
                dbAO = 0;
        else
                dbAO = atof(txtSetAO3->Text.c_str());
        DWORD ret = AO_SetAO(mHandle, 3, dbAO);
}
//---------------------------------------------------------------------------
void __fastcall TBCB5024Main::cmdSetPower3Click(TObject *Sender)
{
        DWORD ret = AO_SetPowerOnValue(mHandle, 3);
}
//---------------------------------------------------------------------------
