//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "BCB5017.h"
#include "..\..\..\include\BlockIOAPI.h"
#include "..\..\..\include\BlockIO5017.h"

#pragma link "..\\..\\..\\library\\bcbBlockIOAPIr.lib"
#pragma link "..\\..\\..\\library\\bcbBlockIO5017r.lib"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TBCB5017Main *BCB5017Main;
//---------------------------------------------------------------------------
__fastcall TBCB5017Main::~TBCB5017Main(void)
{
        Timer1->Enabled = FALSE;
        if(mHandle) SYS_Release(mHandle);
}
//---------------------------------------------------------------------------
__fastcall TBCB5017Main::TBCB5017Main(TComponent* Owner)
        : TForm(Owner)
{
        IR->ItemIndex=0;
        memset(m_bCheck,0,8);
        mHandle = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TBCB5017Main::OpenClick(TObject *Sender)
{
        if(IA->Text.IsEmpty())
        {
                Application->MessageBox("Please input IP address!",
                 "System Message", MB_APPLMODAL|MB_OK|MB_ICONSTOP);
                return;
        }

        DWORD dwRet = SYS_Install(&mHandle, IA->Text.c_str());
        if(!ERR_OK(dwRet))
        {
                dwRet = dwRet & 0x00FF;
                Application->MessageBox(Format("Function SYS_Install returns error code: %d!", ARRAYOFCONST(((int)dwRet))).c_str(),
                 "System Message", MB_APPLMODAL|MB_OK|MB_ICONSTOP);
                Open->Enabled = TRUE;
                return;
        }
        char szBuf[20] = "";
        SYS_GetModuleName(mHandle, szBuf, 20);
        MN->Text = szBuf;

        memset(szBuf, 0, sizeof(szBuf));
        SYS_GetModuleFirmware(mHandle, szBuf, 20);
        FV->Text = szBuf;
        Open->Enabled = FALSE;
        Close->Enabled = TRUE;
        BOOL bEnabled;
        double dblWDTimer;
        SYS_GetWatchDogConfig(mHandle, &bEnabled, &dblWDTimer);
        WD->Checked = bEnabled;
        WDT->Text = Format("%f", ARRAYOFCONST((dblWDTimer)));
        WD->Enabled = TRUE;
        WDT->Enabled = TRUE;
        Update->Enabled = TRUE;
        UpdateIR->Enabled = TRUE;
        IR->Enabled = TRUE;
        //Get Input Range
        BYTE pbyInputRange;
        DWORD ret = AI_GetInputRange(mHandle, &pbyInputRange);
        int nIdx = (int) pbyInputRange;
        if (nIdx>=8)
            nIdx-=0x8;
        else
            nIdx=0;
        IR->ItemIndex = nIdx;

        //
        //JetIO5017
        Check0->Enabled = TRUE;
        Check1->Enabled = TRUE;
        Check2->Enabled = TRUE;
        Check3->Enabled = TRUE;
        Check4->Enabled = TRUE;
        Check5->Enabled = TRUE;
        Check6->Enabled = TRUE;
        Check7->Enabled = TRUE;

        Text0->Enabled = TRUE;
        Text1->Enabled = TRUE;
        Text2->Enabled = TRUE;
        Text3->Enabled = TRUE;
        Text4->Enabled = TRUE;
        Text5->Enabled = TRUE;
        Text6->Enabled = TRUE;
        Text7->Enabled = TRUE;

        BYTE  status;
        ret = AI_GetChannelStatus(mHandle, &status);
        m_bCheck[0] = status & 0x1;
        Check0->Checked = m_bCheck[0];

        m_bCheck[1] = status & 0x2;
        Check1->Checked = m_bCheck[1];

        m_bCheck[2] = status & 0x4;
        Check2->Checked = m_bCheck[2];

        m_bCheck[3] = status & 0x8;
        Check3->Checked = m_bCheck[3];

        m_bCheck[4] = status & 0x10;
        Check4->Checked = m_bCheck[4];

        m_bCheck[5] = status & 0x20;
        Check5->Checked = m_bCheck[5];

        m_bCheck[5] = status & 0x20;
        Check5->Checked = m_bCheck[5];

        m_bCheck[6] = status & 0x40;
        Check6->Checked = m_bCheck[6];

        m_bCheck[7] = status & 0x80;
        Check7->Checked = m_bCheck[7];

        double dblAI;
        if (m_bCheck[0])
        {
                ret = AI_GetAI(mHandle, 0, &dblAI);
                Text0->Text = Format("%f",ARRAYOFCONST((dblAI)));
        }
        if (m_bCheck[1])
        {
                ret = AI_GetAI(mHandle, 1, &dblAI);
                Text1->Text = Format("%f",ARRAYOFCONST((dblAI)));
        }
        if (m_bCheck[2])
        {
                ret = AI_GetAI(mHandle, 2, &dblAI);
                Text2->Text = Format("%f",ARRAYOFCONST((dblAI)));
        }
        if (m_bCheck[3])
        {
                ret = AI_GetAI(mHandle, 3, &dblAI);
                Text3->Text = Format("%f",ARRAYOFCONST((dblAI)));
        }
        if (m_bCheck[4])
        {
                ret = AI_GetAI(mHandle, 4, &dblAI);
                Text4->Text = Format("%f",ARRAYOFCONST((dblAI)));
        }
        if (m_bCheck[5])
        {
                ret = AI_GetAI(mHandle, 5, &dblAI);
                Text5->Text = Format("%f",ARRAYOFCONST((dblAI)));
        }
        if (m_bCheck[6])
        {
                ret = AI_GetAI(mHandle, 6, &dblAI);
                Text6->Text = Format("%f",ARRAYOFCONST((dblAI)));
        }
        if (m_bCheck[7])
        {
                ret = AI_GetAI(mHandle, 7, &dblAI);
                Text7->Text = Format("%f",ARRAYOFCONST((dblAI)));
        }
        Timer1->Enabled = TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TBCB5017Main::UpdateClick(TObject *Sender)
{
        double dblWDTimer = atof(WDT->Text.c_str());
        SYS_SetWatchDogConfig(mHandle, WD->Checked, dblWDTimer);        
}
//---------------------------------------------------------------------------
void __fastcall TBCB5017Main::WDClick(TObject *Sender)
{
        if (WD->Checked==TRUE)
                SYS_EnableWatchDog(mHandle);
        else
                SYS_DisableWatchDog(mHandle);
}
//---------------------------------------------------------------------------
void __fastcall TBCB5017Main::CloseClick(TObject *Sender)
{
        Timer1->Enabled = FALSE;

        Open->Enabled = TRUE;
        Close->Enabled = FALSE;
        IR->Enabled = FALSE;
        UpdateIR->Enabled = FALSE;
        SYS_Release(mHandle);
        mHandle = NULL;

 //       WD->Checked = FALSE;
        WD->Enabled = FALSE;
        WDT->Enabled = FALSE;
        Update->Enabled = FALSE;
        Open->Enabled = TRUE;

        WDT->Text = "";
        MN->Text = "";
        FV->Text = "";
        Check0->Enabled=FALSE;
        Check1->Enabled=FALSE;
        Check2->Enabled=FALSE;
        Check3->Enabled=FALSE;
        Check4->Enabled=FALSE;
        Check5->Enabled=FALSE;
        Check6->Enabled=FALSE;
        Check7->Enabled=FALSE;

        Text0->Enabled=FALSE;
        Text1->Enabled=FALSE;
        Text2->Enabled=FALSE;
        Text3->Enabled=FALSE;
        Text4->Enabled=FALSE;
        Text5->Enabled=FALSE;
        Text6->Enabled=FALSE;
        Text7->Enabled=FALSE;
}
//---------------------------------------------------------------------------
void __fastcall TBCB5017Main::Timer1Timer(TObject *Sender)
{
        BYTE dwDI, dwDO;
        double dblAI;
        String tmp;
        DWORD ret;
        if (m_bCheck[0])
        {
                ret = AI_GetAI(mHandle, 0, &dblAI);
                Text0->Text = Format("%f",ARRAYOFCONST((dblAI)));
        }
        if (m_bCheck[1])
        {
                ret = AI_GetAI(mHandle, 1, &dblAI);
                Text1->Text = Format("%f",ARRAYOFCONST((dblAI)));
        }
        if (m_bCheck[2])
        {
                ret = AI_GetAI(mHandle, 2, &dblAI);
                Text2->Text = Format("%f",ARRAYOFCONST((dblAI)));
        }
        if (m_bCheck[3])
        {
                ret = AI_GetAI(mHandle, 3, &dblAI);
                Text3->Text = Format("%f",ARRAYOFCONST((dblAI)));
        }
        if (m_bCheck[4])
        {
                ret = AI_GetAI(mHandle, 4, &dblAI);
                Text4->Text = Format("%f",ARRAYOFCONST((dblAI)));
        }
        if (m_bCheck[5])
        {
                ret = AI_GetAI(mHandle, 5, &dblAI);
                Text5->Text = Format("%f",ARRAYOFCONST((dblAI)));
        }
        if (m_bCheck[6])
        {
                ret = AI_GetAI(mHandle, 6, &dblAI);
                Text6->Text = Format("%f",ARRAYOFCONST((dblAI)));
        }
        if (m_bCheck[7])
        {
                ret = AI_GetAI(mHandle, 7, &dblAI);
                Text7->Text = Format("%f",ARRAYOFCONST((dblAI)));
        }

}
//---------------------------------------------------------------------------
void __fastcall TBCB5017Main::UpdateIRClick(TObject *Sender)
{
   BYTE byInputRange;
   int nIdx = IR->ItemIndex;
   nIdx+=0x8;
   byInputRange = (BYTE)nIdx;
   DWORD ret = AI_SetInputRange(mHandle, byInputRange);
}
//---------------------------------------------------------------------------
void __fastcall TBCB5017Main::Check0Click(TObject *Sender)
{
        if (Check0->Checked)
                AI_SetChannelStatus(mHandle, (BYTE)0, (BYTE)1);
        else
                AI_SetChannelStatus(mHandle, (BYTE)0, (BYTE)0);
        m_bCheck[0] =  Check0->Checked;
        Text0->Text="";
}
//---------------------------------------------------------------------------
void __fastcall TBCB5017Main::Check1Click(TObject *Sender)
{
        if (Check1->Checked)
                AI_SetChannelStatus(mHandle, 1, 1);
        else
                AI_SetChannelStatus(mHandle, 1, 0);
        m_bCheck[1] =  Check1->Checked;
        Text1->Text="";
}
//---------------------------------------------------------------------------
void __fastcall TBCB5017Main::Check2Click(TObject *Sender)
{
        if (Check2->Checked)
                AI_SetChannelStatus(mHandle, 2, 1);
        else
                AI_SetChannelStatus(mHandle, 2, 0);
        m_bCheck[2] =  Check2->Checked;
        Text2->Text="";
}
//---------------------------------------------------------------------------

void __fastcall TBCB5017Main::Check3Click(TObject *Sender)
{
        if (Check3->Checked)
                AI_SetChannelStatus(mHandle, 3, 1);
        else
                AI_SetChannelStatus(mHandle, 3, 0);
        m_bCheck[3] =  Check3->Checked;
        Text3->Text="";
}
//---------------------------------------------------------------------------

void __fastcall TBCB5017Main::Check4Click(TObject *Sender)
{
        if (Check4->Checked)
                AI_SetChannelStatus(mHandle, 4, 1);
        else
                AI_SetChannelStatus(mHandle, 4, 0);
        m_bCheck[4] =  Check4->Checked;
        Text4->Text="";
}
//---------------------------------------------------------------------------

void __fastcall TBCB5017Main::Check5Click(TObject *Sender)
{
        if (Check5->Checked)
                AI_SetChannelStatus(mHandle, 5, 1);
        else
                AI_SetChannelStatus(mHandle, 5, 0);
        m_bCheck[5] =  Check5->Checked;
        Text5->Text="";
}
//---------------------------------------------------------------------------

void __fastcall TBCB5017Main::Check6Click(TObject *Sender)
{
        if (Check6->Checked)
                AI_SetChannelStatus(mHandle, 6, 1);
        else
                AI_SetChannelStatus(mHandle, 6, 0);
        m_bCheck[6] =  Check6->Checked;
        Text6->Text="";
}
//---------------------------------------------------------------------------

void __fastcall TBCB5017Main::Check7Click(TObject *Sender)
{
        if (Check7->Checked)
                AI_SetChannelStatus(mHandle, 7, 1);
        else
                AI_SetChannelStatus(mHandle, 7, 0);
        m_bCheck[7] =  Check7->Checked;
        Text7->Text="";
}
//---------------------------------------------------------------------------


