#ifndef BLOCKIO5017_APIS_H
#define BLOCKIO5017_APIS_H

#include "CommDef.h"
#include "HandleDef.h"
#include "ErrorCodeDef.h"

#if !defined(_BIO_APIS_H_)
    #define FUNCEXPORTS  __declspec (dllimport)
#else
    #define FUNCEXPORTS  __declspec (dllexport)
#endif

#ifdef __cplusplus
extern "C"
{
#endif

// BLOCKIO6010: 8-CH Analog Inputs w/DO Module
FUNCEXPORTS DWORD WINAPI AI_GetAI(HANDLE hSession, BYTE byChId, double *pdblAI);
// byStatus : xxxxxxxx  binary
//            7      0  channel
FUNCEXPORTS DWORD WINAPI AI_GetChannelStatus(HANDLE hSession, BYTE *pbyStatus);
// byChId : 0 ~ 7 - single channel, 255 - All channels
FUNCEXPORTS DWORD WINAPI AI_SetChannelStatus(HANDLE hSession, BYTE byChId, BYTE byStatus);

// byCount : 0 ~ 4
FUNCEXPORTS DWORD WINAPI AI_SetSnmpTrapCount(HANDLE hSession, BYTE byCount);

// byCount : 0 ~ 4
FUNCEXPORTS DWORD WINAPI AI_GetSnmpTrapCount(HANDLE hSession, BYTE *pbyCount);

// byChId :  1 ~ 4
FUNCEXPORTS DWORD WINAPI AI_SetSnmpTrapIP(HANDLE hSession, BYTE byChId, LPCTSTR lpszIP);
// byChId :  1 ~ 4
FUNCEXPORTS DWORD WINAPI AI_GetSnmpTrapIP(HANDLE hSession, BYTE byChId, LPTSTR lpszIP);

FUNCEXPORTS DWORD WINAPI AI_ResetSnmpTrap(HANDLE hSession);

// \/\/:
typedef struct tagI5017AlarmInfo
{
	BYTE  byAlarmStatus;	// bit 0
	BYTE  byAlarmMode;		// bit 1
	DWORD dwAlarmAction;	// bit 2
	
	BYTE  byMask;
	BYTE  byResult;

} I5017_ALARM_INFO;

FUNCEXPORTS DWORD WINAPI AI_GetAlarmInfo(HANDLE hSession, I5017_ALARM_INFO* pAlarmInfo);
FUNCEXPORTS DWORD WINAPI AI_SetAlarmInfo(HANDLE hSession, I5017_ALARM_INFO* pAlarmInfo);

FUNCEXPORTS DWORD WINAPI AI_SetAlarmLimits(HANDLE hSession, BYTE byChId, double dblHiVal, double dblLoVal, BYTE byLimitsMask);
FUNCEXPORTS DWORD WINAPI AI_GetAlarmLimits(HANDLE hSession, BYTE byChId, double *pdblHiVal, double *pdblLoVal);

FUNCEXPORTS DWORD WINAPI AI_GetInputRange(HANDLE hSession, BYTE *pbyIR);
FUNCEXPORTS DWORD WINAPI AI_SetInputRange(HANDLE hSession, BYTE byIR);

#ifdef __cplusplus
}
#endif

#endif