#ifndef BLOCKIO5024_APIS_H
#define BLOCKIO5024_APIS_H

#include "CommDef.h"
#include "HandleDef.h"
#include "ErrorCodeDef.h"

#if !defined(_BIO_APIS_H_)
    #define FUNCEXPORTS  __declspec (dllimport)
#else
    #define FUNCEXPORTS  __declspec (dllexport)
#endif

#ifdef __cplusplus
extern "C"
{
#endif

#define I5024_CH_NUM	4
typedef struct tagI5024Param
{
	BYTE byOutputRanges[I5024_CH_NUM];
	BYTE bySlewRates[I5024_CH_NUM];
	BYTE byMask;			// bit 0: Output Range
							// bit 1: Slew Rate
	BYTE byResult;
	BYTE bydummy[2];

} I5024_PARAM;

FUNCEXPORTS DWORD WINAPI AO_SetConfig(HANDLE hSession, I5024_PARAM *pParams);
FUNCEXPORTS DWORD WINAPI AO_GetConfig(HANDLE hSession, I5024_PARAM *pParams);

FUNCEXPORTS DWORD WINAPI AO_GetAO(HANDLE hSession, BYTE byChId, double *pdblAO);
FUNCEXPORTS DWORD WINAPI AO_SetAO(HANDLE hSession, BYTE byChId, double dblAO);

FUNCEXPORTS DWORD WINAPI AO_GetPowerOnValue(HANDLE hSession, BYTE byChId, WORD *pwVal);
FUNCEXPORTS DWORD WINAPI AO_SetPowerOnValue(HANDLE hSession, BYTE byChId);

// byCount : 0 ~ 4
FUNCEXPORTS DWORD WINAPI AO_SetSnmpTrapCount(HANDLE hSession, BYTE byCount);

// byCount : 0 ~ 4
FUNCEXPORTS DWORD WINAPI AO_GetSnmpTrapCount(HANDLE hSession, BYTE *pbyCount);

// byChId :  1 ~ 4
FUNCEXPORTS DWORD WINAPI AO_SetSnmpTrapIP(HANDLE hSession, BYTE byChId, LPCTSTR lpszIP);

// byChId :  1 ~ 4
FUNCEXPORTS DWORD WINAPI AO_GetSnmpTrapIP(HANDLE hSession, BYTE byChId, LPTSTR lpszIP);

#ifdef __cplusplus
}
#endif

#endif