#ifndef BLOCKIO_SYS_APIS_H
#define BLOCKIO_SYS_APIS_H

#include "CommDef.h"
#include "HandleDef.h"
#include "ErrorCodeDef.h"

#if !defined(_BLOCKIO_SYS_APIS_H_)
    #define FUNCEXPORTS  __declspec (dllimport)
#else
    #define FUNCEXPORTS  __declspec (dllexport)
#endif

#ifdef __cplusplus
extern "C"
{
#endif
typedef struct tagBLOCKIOPassword
{
	BOOL bEnabled;
	char szPasswd[7];
} BLOCKIO_PASSWORD;

FUNCEXPORTS DWORD WINAPI SYS_Install(HANDLE *phHandle, LPCTSTR lpszAddress);
FUNCEXPORTS DWORD WINAPI SYS_Release(HANDLE hHandle);

FUNCEXPORTS DWORD WINAPI SYS_GetPassword(HANDLE hHandle, BLOCKIO_PASSWORD *ptPassWd);
FUNCEXPORTS DWORD WINAPI SYS_SetPassword(HANDLE hHandle, BLOCKIO_PASSWORD *ptPassWd);
FUNCEXPORTS DWORD WINAPI SYS_ResotreCoeff(HANDLE hHandle);


FUNCEXPORTS DWORD WINAPI SYS_EnableWatchDog(HANDLE Handle);

FUNCEXPORTS DWORD WINAPI SYS_DisableWatchDog(HANDLE Handle);

FUNCEXPORTS DWORD WINAPI SYS_SetWatchDogConfig(HANDLE Handle,
												  BOOL   bEnabled,
												  double dblWDTimer);

FUNCEXPORTS DWORD WINAPI SYS_GetWatchDogConfig(HANDLE Handle,
												 BOOL *pbEnabled,
												 double *pdblWDTimer);

FUNCEXPORTS DWORD WINAPI SYS_ResetWatchDog(HANDLE Handle);

FUNCEXPORTS DWORD WINAPI SYS_GetModuleName(HANDLE Handle,
											 char *pszModuleName,
											 size_t nSize);

FUNCEXPORTS DWORD WINAPI SYS_GetModuleFirmware(HANDLE Handle,
												 char *pszFirmwareVersion,
												 size_t nSize);

FUNCEXPORTS DWORD WINAPI SYS_GetResetStatus(HANDLE Handle,
											   WORD *pwVal);

FUNCEXPORTS DWORD WINAPI SYS_ReadDiscreteModuleValues(HANDLE hSession, BYTE byType, UINT nAddr, BYTE *pcbData, size_t cbSize, size_t bitCount);
FUNCEXPORTS DWORD WINAPI SYS_ReadModuleValues(HANDLE hSession, BYTE byType, UINT nAddr, WORD *pcwData, size_t cwSize, size_t wordCount);
FUNCEXPORTS DWORD WINAPI SYS_WriteDiscreteModuleValues(HANDLE hSession, UINT nAddr, BYTE *pcbData, size_t cbSize, size_t bitCount, BOOL bBroadcast);
FUNCEXPORTS DWORD WINAPI SYS_WriteModuleValues(HANDLE hSession, UINT nAddr, WORD *pcwData, size_t cwSize, size_t wordCount, BOOL bBroadcast);
// /\/\:


#ifdef __cplusplus
}
#endif

#endif