using System;
using System.Runtime.InteropServices;
using System.Text;

namespace BlockIOSDK
{
    [StructLayout(LayoutKind.Sequential, Pack = 1)]
    public struct I5017_ALARM_INFO
    {
        public byte byAlarmStatus;
        public byte byAlarmMode;
        public uint dwAlarmAction;
        public byte byMask;
        public byte byResult;
    }

    public class BlockIO5017r
    {
        [DllImport("BlockIO5017r.dll", EntryPoint = "AI_GetAI")]
        public static extern uint AI_GetAI(IntPtr hSession, byte byChId, out double pdblAI);

        [DllImport("BlockIO5017r.dll", EntryPoint = "AI_GetChannelStatus")]
        public static extern uint AI_GetChannelStatus(IntPtr hSession, out byte pbyStatus);

        [DllImport("BlockIO5017r.dll", EntryPoint = "AI_SetChannelStatus")]
        public static extern uint AI_SetChannelStatus(IntPtr hSession, byte byChId, byte byStatus);

        [DllImport("BlockIO5017r.dll", EntryPoint = "AI_SetSnmpTrapCount")]
        public static extern uint AI_SetSnmpTrapCount(IntPtr hSession, byte byCount);

        [DllImport("BlockIO5017r.dll", EntryPoint = "AI_GetSnmpTrapCount")]
        public static extern uint AI_GetSnmpTrapCount(IntPtr hSession, out byte pbyCount);

        [DllImport("BlockIO5017r.dll", EntryPoint = "AI_SetSnmpTrapIP")]
        public static extern uint AI_SetSnmpTrapIP(IntPtr hSession, byte byChId, [MarshalAs(UnmanagedType.LPTStr)]string lpszIP);

        [DllImport("BlockIO5017r.dll", EntryPoint = "AI_GetSnmpTrapIP")]
        public static extern uint AI_GetSnmpTrapIP(IntPtr hSession, byte byChId, [MarshalAs(UnmanagedType.LPTStr)]StringBuilder lpszIP);

        [DllImport("BlockIO5017r.dll", EntryPoint = "AI_ResetSnmpTrap")]
        public static extern uint AI_ResetSnmpTrap(IntPtr hSession);

        [DllImport("BlockIO5017r.dll", EntryPoint = "AI_GetAlarmInfo")]
        public static extern uint AI_GetAlarmInfo(IntPtr hSession, out I5017_ALARM_INFO pAlarmInfo);

        [DllImport("BlockIO5017r.dll", EntryPoint = "AI_SetAlarmInfo")]
        public static extern uint AI_SetAlarmInfo(IntPtr hSession, ref I5017_ALARM_INFO pAlarmInfo);

        [DllImport("BlockIO5017r.dll", EntryPoint = "AI_SetAlarmLimits")]
        public static extern uint AI_SetAlarmLimits(IntPtr hSession, byte byChId, double dblHiVal, double dblLoVal, byte byLimitsMask);

        [DllImport("BlockIO5017r.dll", EntryPoint = "AI_GetAlarmLimits")]
        public static extern uint AI_GetAlarmLimits(IntPtr hSession, byte byChId, out double pdblHiVal, out double pdblLoVal);

        [DllImport("BlockIO5017r.dll", EntryPoint = "AI_GetInputRange")]
        public static extern uint AI_GetInputRange(IntPtr hSession, out byte pbyIR);

        [DllImport("BlockIO5017r.dll", EntryPoint = "AI_SetInputRange")]
        public static extern uint AI_SetInputRange(IntPtr hSession, byte byIR);
    }
}
